Attribute VB_Name = "mWinAPI"
'**********************************************************************************
'API used to retrieve the ComputerName of the current local system.
Public Declare Function GetComputerName Lib "kernel32" Alias _
"GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
'**********************************************************************************

'**********************************************************************************
'API`s used to retrieve Folders, Files and Information.
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" _
(ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long

Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" _
(ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long

Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Private Const MAX_PATH = 260
Private Const AMAX_PATH = 260

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA                  'Public Type
    dwFileAttributes As Long                 'Specifies the file attributes of the file found.
    ftCreationTime As FILETIME               'Specifies a FILETIME structure containing the time the file was created.
    ftLastAccessTime As FILETIME             'Specifies a FILETIME structure containing the time that the file was last accessed.
    ftLastWriteTime As FILETIME              'Specifies a FILETIME structure containing the time that the file was last written to.
    nFileSizeHigh As Long                    'Specifies the high-order DWORD value of the file size, in bytes.
    nFileSizeLow As Long                     'Specifies the low-order DWORD value of the file size, in bytes.
    dwReserved0 As Long                      'If the dwFileAttributes member includes the FILE_ATTRIBUTE_REPARSE_POINT attribute, this member specifies the reparse tag. Otherwise, this value is undefined and should not be used.
    dwReserved1 As Long                      'Reserved for future use.
    cFileName As String * MAX_PATH           'A null-terminated string that is the name of the file.
    cAlternateFileName As String * AMAX_PATH 'A null-terminated string that is an alternative name for the file.
End Type

Public Enum FILE_ATTRIBUTES           'Self explanitary
    FILE_ATTRIBUTE_READONLY = &H1
    FILE_ATTRIBUTE_ARCHIVE = &H20
    FILE_ATTRIBUTE_SYSTEM = &H4
    FILE_ATTRIBUTE_HIDDEN = &H2
    FILE_ATTRIBUTE_NORMAL = &H80
    FILE_ATTRIBUTE_ENCRYPTED = &H4000
End Enum
'**********************************************************************************

'***********************************************************************************
'The FileTimeToSystemTime function converts a 64-bit file time to system time format.
Public Declare Function FileTimeToSystemTime Lib "kernel32" _
(lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long

Public Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type
'***********************************************************************************

'***********************************************************************************
'The GetLogicalDriveStrings function fills a buffer with strings that specify valid
'drives in the system.
Public Declare Function GetLogicalDriveStrings Lib "kernel32" Alias _
"GetLogicalDriveStringsA" (ByVal nBufferLength As Long, _
ByVal lpBuffer As String) As Long
'***********************************************************************************


'***********************************************************************************
'The GetDriveType function determines whether a disk drive is a removable, fixed,
'CD-ROM, RAM disk, or network drive.
Public Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" _
(ByVal nDrive As String) As Long
'***********************************************************************************

'***********************************************************************************
'The GetVolumeInformation function returns information about a file system and
'volume whose root directory is specified.
Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" _
(ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, _
ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, _
lpMaximumComponentLength As Long, lpFileSystemFlags As Long, _
ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long
'***********************************************************************************


'***********************************************************************************
'ShellExecute (Opens or prints a specified File.)
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
(ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
ByVal lpParameters As String, ByVal lpDirectory As String, _
ByVal nShowCmd As Long) As Long

Public Const SW_SHOWNORMAL = 1
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_SHOWMAXIMIZED = 3
Public Const SW_SHOWDEFAULT = 10
'***********************************************************************************


